<script setup>
const filterResource = (resource) => {
  const fieldsExist = resource.resource && resource.page && resource.description && resource.image && resource.link;
  const notGithub = !resource.link.includes("github.com");
  return fieldsExist && notGithub;
}

const formatDesc = (desc) => {
  // first 180 chars of the description + ...
  if (desc.length < 180) return desc;
  return desc.slice(0, 180) + " ...";
}

const formatTitle = (title) => {
  // first 30 chars of the title + ...
  if (title.length < 80) return title;
  return title.slice(0, 80) + " ...";
}
const resourcesRequest = await queryContent("/resources").findOne();
//filter out the resources with empty fields
const resources = Array.from(resourcesRequest.body)
  .filter(filterResource)
  .map((resource) => ({
    title: formatTitle(resource.resource),
    subtitle: resource.page,
    text: formatDesc(resource.description),
    img: resource.image,
    link: resource.link,
  }));
</script>

<template>
  <div class="p-4 sm:p-8 lg:p-16 grid-row grid-cols-2 sm:grid-cols-3 lg:grid-cols-4 justify-items-stretch">
    <div
      v-for="resource in resources"
      :key="resource.title"
      :title="resource.title"
      :subtitle="resource.subtitle"
      :text="resource.text"
    >
    {{ resource.title }}
      <div class="a-card-body">
        <a target="_blank" :href="resource.link"><ABtn>Read more</ABtn></a>
      </div>
    </div>
</div>
</template>
